/***********************************************************************/
/* Program     :  sqltext.rex                                          */
/* Version     :  1.00                                                 */
/* Author      :  Mark Hessling                                        */
/* Date        :  03 Apr 1995                                          */
/* Purpose     :  This program displays the full text of the SQL       */
/*             :  statement for the supplied process id(s).            */
/*             :  *** Does not run with Oracle Version 6 ***           */
/* Arguments   :  Process id(s) seperated by spaces.                   */
/***********************************************************************/
Trace o
processes = ''
user = 'system/manager'
Do i = 1 To Arg()
   processes = processes Arg(i)
End
processes = Strip(processes)
If processes = '' Then
  Do
    Say 'ERROR: Must supply at least one process id'
    Exit 1
  End
query0 = "select osuser,sql_text",
         " from v$session s,v$sqlarea t,v$process p",
         " where s.sql_address = t.address",
         " and  s.sql_hash_value = t.hash_value",
         " and  p.spid = :APROC",
         " and  p.addr = s.paddr"

If sqlconnect(user) < 0 Then Abort()
Do i = 1 To Words(processes)
   If sqlcommand(q0,query0,':APROC',Word(processes,i)) < 0 Then Abort()
   Say
   If q0.sql_text.0 = 0 Then Say Word(processes,i)||': No SQL text available for process'
   Else
     Do
       Say Word(processes,i)||': SQL Text for process owned by' q0.osuser.1
       Do While q0.sql_text.1 \= ''
         Say Substr(q0.sql_text.1,1,60)
         q0.sql_text.1 = Substr(q0.sql_text.1,61)
       End
     End
End
Return

/*---------------------------------------------------------------------*/
/* General error message handler.                                      */
/*---------------------------------------------------------------------*/
Abort: Procedure Expose sqlca.
Parse Arg text
If text = '' Then Say sqlca.sqlerrm
Else Say text
Exit 1
Return
